#include <ped.h>
Ped::Ped() : thr(&Ped::update, this)
{
	logmsg("Ped: spawn");
	createRandomPedsAt3DCoords(1000, 0, 0, 0);
}
Ped::~Ped(void)
{
	logmsg("Ped: destroy");
for(int i = 0; i < getSize(); i++)
{
	del(i);
}
}
void Ped::installAudio(Audio &a)
{
this->audio = &a;
}
void Ped::createRandomPedsAt3DCoords(int peds, float _x, float _y, float _z)
{
	logmsg("Ped: creating %i peds at %.2f %.2f %.2f", peds, _x, _y, _z);
	srand(time(NULL));
	float x = _x;
	float y = _y;
	float z = _z;
	for (int i = 0; i < peds; i++)
	{
		Pedd pd;
		pd.big = false;
		pd.health = 100;
		pd.jump = 1;
		if (_x == 0.0f && _y == 0.0f && _z == 0.0f)
		{
			if (rand() % 10 > 4) pd.big = true; else pd.big = false;
				pd.x = rand() % 6000;
				pd.y = rand() % 6000;
				pd.z = 0;
			}
else
{
pd.x = _x;
pd.y = _y;
pd.z = _z;
}
if(i <= 100)
{
pd.t = CAT;
pd.interval = 110;
}
else if(i > 100 && i <= 200)
{
pd.t = COW;
pd.interval = 100;
}
else if(i > 200 && i <= 300)
{
	pd.t = DOG;
	pd.interval = 110;
}
else if(i > 300 && i <= peds)
{
pd.t = HUMAN;
pd.interval = 225;
}
		int radius = 40;
		if (pd.big) radius *= 1.5;
		float vx, vy;
		vx = (rand() % 2) + 1;
		vy = (rand() % 2) + 1;
		if (rand() % 2 == 0) vx*=-1;
		if (rand() % 2 == 0) vy *= -1;
		pd.speed = sf::Vector2f(vx / 1.5, vy / 1.5);
		a_ped.push_back(pd);
	}
	logmsg("Ped: done");
}
void Ped::del(int in)
{
	for (int i = in; i < a_ped.size() - 1; i++)
	{
		swap(a_ped[i], a_ped[i + 1]);
	}
	a_ped.resize(a_ped.size() - 1);
}
int Ped::getSize()
{
	return a_ped.size();
}
Ped::PED_TYPE Ped::getType(int index)
{
return a_ped[index].t;
}
void Ped::setHealth(int index, int h)
{
	a_ped[index].health = h;
}
int Ped::getHealth(int index)
{
	return a_ped[index].health;
}
void Ped::setCoords(int ind, float &xx, float &yy, float &zz)
{
	a_ped[ind].x = xx;
	a_ped[ind].y = yy;
	a_ped[ind].z = zz;
}
void Ped::update()
{
srand(time(NULL));
			if(getSize() > 0)
		{
for(int d = 0; d < getSize(); d++)
{
if ((a_ped[d].t == CAT))
		{
			czas[0] = clock[0].getElapsedTime();
			if (czas[0].asSeconds() <= 30)
			{
				a_ped[d].tim[2] = a_ped[d].clk[2].getElapsedTime();
				if (a_ped[d].tim[2].asSeconds() >= 5)
				{
					audio->play3DSound(audio->MEOF01, a_ped[d].x, a_ped[d].y, a_ped[d].z);
										a_ped[d].clk[2].restart();
				}
				if (a_ped[d].x <= -2000)
{
goToCoords(d, 2000, a_ped[d].y, 0, CAT);
}
else if (a_ped[d].x >= 2000)
{
goToCoords(d, -2000, a_ped[d].y, 0, CAT);
}
				if (a_ped[d].y <= -2000)
{
goToCoords(d, a_ped[d].x, 2000, 0, CAT);
}
else if (a_ped[d].y >= 2000)
{
goToCoords(d, a_ped[d].x, -2000, 0, CAT);
}
			}
			else if (czas[0].asSeconds() > 30 && czas[0].asSeconds() <= 60)
			{
				a_ped[d].tim[1] = a_ped[d].clk[1].getElapsedTime();
				if (a_ped[d].tim[1].asSeconds() >= 5)
				{
					audio->play3DSound(audio->PURE01, a_ped[d].x, a_ped[d].y, a_ped[d].z);
					audio->setSoundLoop(audio->PURE01, true);
					a_ped[d].clk[1].restart();
				}
				if (a_ped[d].x <= -2000)
{
goToCoords(d, rand() % 2000, a_ped[d].y, 0, CAT);
}
else if (a_ped[d].x >= 2000)
{
goToCoords(d, rand() % -2000, a_ped[d].y, 0, CAT);
}
				if (a_ped[d].y <= -2000)
{
goToCoords(d, a_ped[d].x, rand() % 2000, 0, CAT);
}
else if (a_ped[d].y >= 2000)
{
goToCoords(d, a_ped[d].x, rand() % -2000, 0, CAT);
}
clock[0].restart();
			}
		}
else if ((a_ped[d].t = COW))
		{
			czas[1] = clock[1].getElapsedTime();
			if (czas[1].asSeconds() > 30)
			{
				a_ped[d].tim[2] = a_ped[d].clk[2].getElapsedTime();
				if (a_ped[d].tim[2].asSeconds() > 5)
				{
										int sound0 = rand() % 2;
if(sound0 == 0) 
{
audio->play3DSound(audio->M01, a_ped[d].x, a_ped[d].y, a_ped[d].z);
}
else if(sound0 != 0) 
{
audio->play3DSound(audio->M02, a_ped[d].x, a_ped[d].y, a_ped[d].z);
}
										a_ped[d].clk[2].restart();
				}
				if (a_ped[d].x <= -3000) 
{
goToCoords(d, 3000, a_ped[d].y, 0, COW);
}
else if (a_ped[d].x >= 3000)
{
goToCoords(d, -3000, a_ped[d].y, 0, COW);
}
				if (a_ped[d].y <= -3000)
{
goToCoords(d, a_ped[d].x, 3000, 0, COW);
}
else if (a_ped[d].y >= 3000)
{
goToCoords(d, a_ped[d].x, -3000, 0, COW);
}
			}
			else if (czas[2].asSeconds() > 120)
			{
				a_ped[d].tim[1] = a_ped[d].clk[1].getElapsedTime();
				if (a_ped[d].tim[1].asSeconds() > 5)
				{
			audio->play3DSound(audio->M03, a_ped[d].x, a_ped[d].y, a_ped[d].z);
										a_ped[d].clk[1].restart();
				}
								clock[1].restart();
			}
		}
else if ((a_ped[d].t == DOG))
		{
clock[2].restart();
			czas[2] = clock[2].getElapsedTime();
			if (czas[2].asSeconds() <= 30)
			{
				a_ped[d].tim[2] = a_ped[d].clk[2].getElapsedTime();
				if (a_ped[d].tim[2].asSeconds() >= 5)
				{
					int sound1 = rand() % 2;
					if(sound1 == 0) audio->play3DSound(audio->DOG01, a_ped[d].x, a_ped[d].y, a_ped[d].z); else if(sound1 != 0) audio->play3DSound(audio->DOG02, a_ped[d].x, a_ped[d].y, a_ped[d].z);
										a_ped[d].clk[2].restart();
				}
				if (a_ped[d].x <= -2000) goToCoords(d, rand() % 2000, a_ped[d].y, 0, DOG); else if (a_ped[d].x >= 2000) goToCoords(d, rand() % -2000, a_ped[d].y, 0, DOG);
				if (a_ped[d].y <= -2000) goToCoords(d, a_ped[d].x, rand() % 2000, 0, DOG); else if (a_ped[d].y >= 2000) goToCoords(d, a_ped[d].x, rand() % -2000, 0, DOG);
			}
			else if (czas[2].asSeconds() > 30 && czas[2].asSeconds() <= 60)
			{
				a_ped[d].tim[1] = a_ped[d].clk[1].getElapsedTime();
				if (a_ped[d].tim[1].asSeconds() >= 5)
				{
					audio->play3DSound(audio->DOG03, a_ped[d].x, a_ped[d].y, a_ped[d].z);
										a_ped[d].clk[1].restart();
				}
				if (a_ped[d].x <= -2000) goToCoords(d, rand() % 2000, a_ped[d].y, 0, DOG); else if (a_ped[d].x >= 2000) goToCoords(d, rand() % -2000, a_ped[d].y, 0, DOG);
				if (a_ped[d].y <= -2000) goToCoords(d, a_ped[d].x, rand() % 2000, 0, DOG); else if (a_ped[d].y >= 2000) goToCoords(d, a_ped[d].x, rand() % -2000, 0, DOG);
				clock[2].restart();
			}
		}
	if(a_ped[d].health == 0)
{
del(d);
}
if(a_ped[d].x > 11000)
{
 a_ped[d].x = 11000;
}
else if(a_ped[d].y > 11000)
{
a_ped[d].y = 11000;
}




}

}
}
void Ped::goToCoords(int ind, float x, float y, float z, PED_TYPE t)
{
	do{
	a_ped[ind].tim[0] = a_ped[ind].clk[0].getElapsedTime();
	if(a_ped[ind].tim[0].asMilliseconds() >= a_ped[ind].interval)
	{
		if(a_ped[ind].x < x)
{
a_ped[ind].x += 1;
}
else if(a_ped[ind].x > x)
{
a_ped[ind].x -= 1;
}
				if(a_ped[ind].y < y)
{
a_ped[ind].y += 1;
}
else if(a_ped[ind].y > y)
{
a_ped[ind].y -= 1;
}
				if(t == CAT || t == DOG)
				{
				audio->play3DSound(audio->STEP7, a_ped[ind].x, a_ped[ind].y, a_ped[ind].z);
				}
				else if(t == HUMAN)
				{
					audio->play3DSound(audio->STEP6, a_ped[ind].x, a_ped[ind].y, a_ped[ind].z);
				}
				else if(t == COW)
				{
					audio->play3DSound(audio->STEP8, a_ped[ind].x, a_ped[ind].y, a_ped[ind].z);
				}
				a_ped[ind].clk[0].restart();
	}
	} while(a_ped[ind].x != x || a_ped[ind].y != y || a_ped[ind].z != z);
}
void Ped::launchThread()
{
	thr.launch();
}
void Ped::terminateThread()
{
	thr.terminate();
}
Vector3D Ped::getCoords(int index)
{
return {a_ped[index].x, a_ped[index].y, a_ped[index].z};
}
